//
//  SamllAdvertisementView.m
//  Tumour-Doctor
//
//  Created by xrz on 2017/3/17.
//  Copyright © 2017年 李林. All rights reserved.
//

#import "SmallAdvertisementView.h"
#import "TitleTipCell.h"
@interface SmallAdvertisementView ()<UICollectionViewDelegate,UICollectionViewDataSource,UICollectionViewDelegateFlowLayout>
{
    NSTimer *timer;
    CGFloat currentWidth;
    NSInteger numberOfItems;//需要返回的item的个数
}

@property (nonatomic,strong) UICollectionView *collectionView;

@end

@implementation SmallAdvertisementView
/**
 懒加载
 */
-(UICollectionView *)collectionView
{
    if (_collectionView == nil)
    {
        UICollectionViewFlowLayout *flowLayout = [[UICollectionViewFlowLayout alloc] init];
        flowLayout.scrollDirection = UICollectionViewScrollDirectionHorizontal;
        _collectionView = [[UICollectionView alloc] initWithFrame:CGRectMake(44, 0, MDK_SCREEN_WIDTH-88, 44) collectionViewLayout:flowLayout];
        _collectionView.backgroundColor = [UIColor clearColor];
        _collectionView.delegate = self;
        _collectionView.dataSource = self;
        _collectionView.showsHorizontalScrollIndicator = NO;
        _collectionView.scrollEnabled = NO;
        [_collectionView registerClass:[TitleTipCell class] forCellWithReuseIdentifier:@"cell"];
    }
    return _collectionView;
}

-(void)setTipString:(NSString *)tipString
{
    _tipString = tipString;
    currentWidth = [tipString boundingRectWithSize:CGSizeMake(1000, 44) options:NSStringDrawingUsesLineFragmentOrigin|NSStringDrawingUsesFontLeading|NSStringDrawingTruncatesLastVisibleLine attributes:@{NSFontAttributeName :[UIFont systemFontOfSize:16.]} context:nil].size.width+10;
    //判断提示语的字符宽度
    if (currentWidth > self.collectionView.frame.size.width)
    {
        numberOfItems = 3;
        [self addTimer];
    }
    else
    {
        numberOfItems = 1;
    }
    [self.collectionView reloadData];
}

-(instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self)
    {
        self.backgroundColor = UIColorFromRGB(0xf0faf6);
        [self createSubviews];
        
    }
    return self;
}


/**
 创建子视图
 */
- (void)createSubviews
{
    UIImageView *leftImage = [[UIImageView alloc] initWithFrame:CGRectMake(0, 0, 44, 44)];
    leftImage.backgroundColor = [UIColor clearColor];
    leftImage.image = [UIImage imageNamed:@"ggl_lb_icon"];
    [self addSubview:leftImage];
    
    UIButton *rightBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    rightBtn.backgroundColor = [UIColor clearColor];
    rightBtn.frame = CGRectMake(MDK_SCREEN_WIDTH-44, 0, 44, 44);
    [rightBtn setImage:[UIImage imageNamed:@"ggl_x_close"] forState:UIControlStateNormal];
    [rightBtn addTarget:self
                 action:@selector(closeBtnClickAction)
       forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:rightBtn];
    
    [self addSubview:self.collectionView];
}


#pragma mark - NSTimer
/**
 * 添加定时器
 */
- (void)addTimer
{
    timer = [NSTimer scheduledTimerWithTimeInterval:0.02 target:self selector:@selector(scrollCollectionView) userInfo:nil repeats:YES];
    [[NSRunLoop currentRunLoop] addTimer:timer forMode:NSRunLoopCommonModes];
}

/**
 * 移除定时器
 */
- (void)removeTimer
{
    if (timer.isValid)
    {
        [timer invalidate];
        timer = nil;
    }
}

- (void)scrollCollectionView
{
    CGFloat x= self.collectionView.contentOffset.x;
    if (x < (self.collectionView.contentSize.width-MDK_SCREEN_WIDTH+87))
    {
        self.collectionView.contentOffset = CGPointMake(x+1, 0);
        NSLog(@"%f",self.collectionView.contentSize.width-MDK_SCREEN_WIDTH+87-x);
    }
    else
    {
        [self.collectionView scrollToItemAtIndexPath:[NSIndexPath indexPathForItem:0 inSection:0] atScrollPosition:UICollectionViewScrollPositionLeft animated:NO];
        CGFloat socroll_x = currentWidth -MDK_SCREEN_WIDTH+88;
        self.collectionView.contentOffset = CGPointMake(socroll_x , 0);
    }
}


#pragma mark - UICollectionViewDataSource
- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section
{
    return numberOfItems;
}

// The cell that is returned must be retrieved from a call to -dequeueReusableCellWithReuseIdentifier:forIndexPath:
- (__kindof UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath
{
    TitleTipCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"cell" forIndexPath:indexPath];
    cell.name.text = self.tipString;
    cell.name.frame = CGRectMake(0, 0, currentWidth, 44);
    return cell;
}

#pragma mark - UICollectionViewDelegateFlowLayout
- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath
{
    return CGSizeMake(currentWidth, 44);
}


#pragma mark - actions
- (void)closeBtnClickAction
{
    [self removeTimer];
    if (self.closeBtnClick)
    {
        self.closeBtnClick(self);
    }
    
}


/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
